ogma-language-c-1.10.0: Ogma: Runtime Monitor translator: C Language Frontend

Safe Haskell | Safe-Inferred
Language | Haskell2010

Language.C.AbsC

Description

The abstract syntax of language C.

# Documentation

data TranslationUnit Source #

Constructors

MkTranslationUnit [ExternalDeclaration] |

#### Instances

Instances details

Read TranslationUnit Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TranslationUnit Source # readList :: ReadS [TranslationUnit] Source # readPrec :: ReadPrec TranslationUnit Source # readListPrec :: ReadPrec [TranslationUnit] Source #
Show TranslationUnit Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TranslationUnit -> ShowS Source # show :: TranslationUnit -> String Source # showList :: [TranslationUnit] -> ShowS Source #
Eq TranslationUnit Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TranslationUnit -> TranslationUnit -> Bool Source # (/=) :: TranslationUnit -> TranslationUnit -> Bool Source #
Ord TranslationUnit Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: TranslationUnit -> TranslationUnit -> Ordering Source #

(<) :: TranslationUnit -> TranslationUnit -> Bool Source #

(<=) :: TranslationUnit -> TranslationUnit -> Bool Source #

(>) :: TranslationUnit -> TranslationUnit -> Bool Source #

(>=) :: TranslationUnit -> TranslationUnit -> Bool Source #

max :: TranslationUnit -> TranslationUnit -> TranslationUnit Source #

min :: TranslationUnit -> TranslationUnit -> TranslationUnit Source #

Print TranslationUnit Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TranslationUnit -> Doc Source #

data ExternalDeclaration Source #

Constructors

MkExternalDeclarationFunctionDefinition FunctionDefinition |
MkExternalDeclarationDeclaration Declaration |

#### Instances

Instances details

Read ExternalDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ExternalDeclaration Source # readList :: ReadS [ExternalDeclaration] Source # readPrec :: ReadPrec ExternalDeclaration Source # readListPrec :: ReadPrec [ExternalDeclaration] Source #
Show ExternalDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ExternalDeclaration -> ShowS Source # show :: ExternalDeclaration -> String Source # showList :: [ExternalDeclaration] -> ShowS Source #
Eq ExternalDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source # (/=) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source #
Ord ExternalDeclaration Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ExternalDeclaration -> ExternalDeclaration -> Ordering Source #

(<) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source #

(<=) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source #

(>) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source #

(>=) :: ExternalDeclaration -> ExternalDeclaration -> Bool Source #

max :: ExternalDeclaration -> ExternalDeclaration -> ExternalDeclaration Source #

min :: ExternalDeclaration -> ExternalDeclaration -> ExternalDeclaration Source #

Print ExternalDeclaration Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ExternalDeclaration -> Doc Source #
Print [ExternalDeclaration] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [ExternalDeclaration] -> Doc Source #

data FunctionDefinition Source #

Constructors

MkFunctionDefinition [DeclarationSpecifier] Declarator [Declaration] CompoundStatement |

#### Instances

Instances details

Read FunctionDefinition Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS FunctionDefinition Source # readList :: ReadS [FunctionDefinition] Source # readPrec :: ReadPrec FunctionDefinition Source # readListPrec :: ReadPrec [FunctionDefinition] Source #
Show FunctionDefinition Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> FunctionDefinition -> ShowS Source # show :: FunctionDefinition -> String Source # showList :: [FunctionDefinition] -> ShowS Source #
Eq FunctionDefinition Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: FunctionDefinition -> FunctionDefinition -> Bool Source # (/=) :: FunctionDefinition -> FunctionDefinition -> Bool Source #
Ord FunctionDefinition Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: FunctionDefinition -> FunctionDefinition -> Ordering Source #

(<) :: FunctionDefinition -> FunctionDefinition -> Bool Source #

(<=) :: FunctionDefinition -> FunctionDefinition -> Bool Source #

(>) :: FunctionDefinition -> FunctionDefinition -> Bool Source #

(>=) :: FunctionDefinition -> FunctionDefinition -> Bool Source #

max :: FunctionDefinition -> FunctionDefinition -> FunctionDefinition Source #

min :: FunctionDefinition -> FunctionDefinition -> FunctionDefinition Source #

Print FunctionDefinition Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> FunctionDefinition -> Doc Source #

data Declaration Source #

Constructors

MkDeclaration DeclarationSpecifiers InitDeclarationListOpt |

#### Instances

Instances details

Read Declaration Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Declaration Source # readList :: ReadS [Declaration] Source # readPrec :: ReadPrec Declaration Source # readListPrec :: ReadPrec [Declaration] Source #
Show Declaration Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Declaration -> ShowS Source # show :: Declaration -> String Source # showList :: [Declaration] -> ShowS Source #
Eq Declaration Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Declaration -> Declaration -> Bool Source # (/=) :: Declaration -> Declaration -> Bool Source #
Ord Declaration Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Declaration -> Declaration -> Ordering Source #

(<) :: Declaration -> Declaration -> Bool Source #

(<=) :: Declaration -> Declaration -> Bool Source #

(>) :: Declaration -> Declaration -> Bool Source #

(>=) :: Declaration -> Declaration -> Bool Source #

max :: Declaration -> Declaration -> Declaration Source #

min :: Declaration -> Declaration -> Declaration Source #

Print Declaration Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Declaration -> Doc Source #
Print [Declaration] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [Declaration] -> Doc Source #

data DeclarationSpecifiers Source #

Constructors

DeclarationSpecifiers DeclarationSpecifier [DeclarationSpecifier] |

#### Instances

Instances details

Read DeclarationSpecifiers Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DeclarationSpecifiers Source # readList :: ReadS [DeclarationSpecifiers] Source # readPrec :: ReadPrec DeclarationSpecifiers Source # readListPrec :: ReadPrec [DeclarationSpecifiers] Source #
Show DeclarationSpecifiers Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DeclarationSpecifiers -> ShowS Source # show :: DeclarationSpecifiers -> String Source # showList :: [DeclarationSpecifiers] -> ShowS Source #
Eq DeclarationSpecifiers Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source # (/=) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source #
Ord DeclarationSpecifiers Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DeclarationSpecifiers -> DeclarationSpecifiers -> Ordering Source #

(<) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source #

(<=) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source #

(>) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source #

(>=) :: DeclarationSpecifiers -> DeclarationSpecifiers -> Bool Source #

max :: DeclarationSpecifiers -> DeclarationSpecifiers -> DeclarationSpecifiers Source #

min :: DeclarationSpecifiers -> DeclarationSpecifiers -> DeclarationSpecifiers Source #

Print DeclarationSpecifiers Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DeclarationSpecifiers -> Doc Source #

data DeclarationSpecifier Source #

Constructors

MkDeclarationSpecifierStorageClass StorageClassSpecifier |
MkDeclarationSpecifierTypeSpecifier TypeSpecifier |
MkDeclarationSpecifierTypeQualifier TypeQualifier |

#### Instances

Instances details

Read DeclarationSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DeclarationSpecifier Source # readList :: ReadS [DeclarationSpecifier] Source # readPrec :: ReadPrec DeclarationSpecifier Source # readListPrec :: ReadPrec [DeclarationSpecifier] Source #
Show DeclarationSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DeclarationSpecifier -> ShowS Source # show :: DeclarationSpecifier -> String Source # showList :: [DeclarationSpecifier] -> ShowS Source #
Eq DeclarationSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source # (/=) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source #
Ord DeclarationSpecifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DeclarationSpecifier -> DeclarationSpecifier -> Ordering Source #

(<) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source #

(<=) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source #

(>) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source #

(>=) :: DeclarationSpecifier -> DeclarationSpecifier -> Bool Source #

max :: DeclarationSpecifier -> DeclarationSpecifier -> DeclarationSpecifier Source #

min :: DeclarationSpecifier -> DeclarationSpecifier -> DeclarationSpecifier Source #

Print DeclarationSpecifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DeclarationSpecifier -> Doc Source #
Print [DeclarationSpecifier] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [DeclarationSpecifier] -> Doc Source #

data StorageClassSpecifier Source #

Constructors

MkStorageClassSpecifierAuto |
MkStorageClassSpecifierRegister |
MkStorageClassSpecifierStatic |
MkStorageClassSpecifierExtern |
MkStorageClassSpecifierTypedef |

#### Instances

Instances details

Read StorageClassSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS StorageClassSpecifier Source # readList :: ReadS [StorageClassSpecifier] Source # readPrec :: ReadPrec StorageClassSpecifier Source # readListPrec :: ReadPrec [StorageClassSpecifier] Source #
Show StorageClassSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> StorageClassSpecifier -> ShowS Source # show :: StorageClassSpecifier -> String Source # showList :: [StorageClassSpecifier] -> ShowS Source #
Eq StorageClassSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source # (/=) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source #
Ord StorageClassSpecifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: StorageClassSpecifier -> StorageClassSpecifier -> Ordering Source #

(<) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source #

(<=) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source #

(>) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source #

(>=) :: StorageClassSpecifier -> StorageClassSpecifier -> Bool Source #

max :: StorageClassSpecifier -> StorageClassSpecifier -> StorageClassSpecifier Source #

min :: StorageClassSpecifier -> StorageClassSpecifier -> StorageClassSpecifier Source #

Print StorageClassSpecifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> StorageClassSpecifier -> Doc Source #

data TypeSpecifier Source #

Constructors

MkTypeSpecifierVoid |
MkTypeSpecifierChar |
MkTypeSpecifierShort |
MkTypeSpecifierInt |
MkTypeSpecifierInt8 |
MkTypeSpecifierInt16 |
MkTypeSpecifierInt32 |
MkTypeSpecifierInt64 |
MkTypeSpecifierUInt8 |
MkTypeSpecifierUInt16 |
MkTypeSpecifierUInt32 |
MkTypeSpecifierUInt64 |
MkTypeSpecifierLong |
MkTypeSpecifierFloat |
MkTypeSpecifierDouble |
MkTypeSpecifierSigned |
MkTypeSpecifierUnsigned |
MkTypeSpecifierStructOrUnion StructOrUnionSpecifier |
MkTypeSpecifierEnumSpecifier EnumSpecifier |

#### Instances

Instances details

Read TypeSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TypeSpecifier Source # readList :: ReadS [TypeSpecifier] Source # readPrec :: ReadPrec TypeSpecifier Source # readListPrec :: ReadPrec [TypeSpecifier] Source #
Show TypeSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TypeSpecifier -> ShowS Source # show :: TypeSpecifier -> String Source # showList :: [TypeSpecifier] -> ShowS Source #
Eq TypeSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TypeSpecifier -> TypeSpecifier -> Bool Source # (/=) :: TypeSpecifier -> TypeSpecifier -> Bool Source #
Ord TypeSpecifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: TypeSpecifier -> TypeSpecifier -> Ordering Source #

(<) :: TypeSpecifier -> TypeSpecifier -> Bool Source #

(<=) :: TypeSpecifier -> TypeSpecifier -> Bool Source #

(>) :: TypeSpecifier -> TypeSpecifier -> Bool Source #

(>=) :: TypeSpecifier -> TypeSpecifier -> Bool Source #

max :: TypeSpecifier -> TypeSpecifier -> TypeSpecifier Source #

min :: TypeSpecifier -> TypeSpecifier -> TypeSpecifier Source #

Print TypeSpecifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TypeSpecifier -> Doc Source #

data TypeQualifier Source #

Constructors

MkTypeQualifierConst |
MkTypeQualifierVolatile |

#### Instances

Instances details

Read TypeQualifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TypeQualifier Source # readList :: ReadS [TypeQualifier] Source # readPrec :: ReadPrec TypeQualifier Source # readListPrec :: ReadPrec [TypeQualifier] Source #
Show TypeQualifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TypeQualifier -> ShowS Source # show :: TypeQualifier -> String Source # showList :: [TypeQualifier] -> ShowS Source #
Eq TypeQualifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TypeQualifier -> TypeQualifier -> Bool Source # (/=) :: TypeQualifier -> TypeQualifier -> Bool Source #
Ord TypeQualifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: TypeQualifier -> TypeQualifier -> Ordering Source #

(<) :: TypeQualifier -> TypeQualifier -> Bool Source #

(<=) :: TypeQualifier -> TypeQualifier -> Bool Source #

(>) :: TypeQualifier -> TypeQualifier -> Bool Source #

(>=) :: TypeQualifier -> TypeQualifier -> Bool Source #

max :: TypeQualifier -> TypeQualifier -> TypeQualifier Source #

min :: TypeQualifier -> TypeQualifier -> TypeQualifier Source #

Print TypeQualifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TypeQualifier -> Doc Source #

data StructOrUnionSpecifier Source #

Constructors

MkStructOrUnionSpecifierWithFields StructOrUnion IdentifierOpt [StructDeclaration] |
MkStructOrUnionSpecifierEmpty StructOrUnion Identifier |

#### Instances

Instances details

Read StructOrUnionSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS StructOrUnionSpecifier Source # readList :: ReadS [StructOrUnionSpecifier] Source # readPrec :: ReadPrec StructOrUnionSpecifier Source # readListPrec :: ReadPrec [StructOrUnionSpecifier] Source #
Show StructOrUnionSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> StructOrUnionSpecifier -> ShowS Source # show :: StructOrUnionSpecifier -> String Source # showList :: [StructOrUnionSpecifier] -> ShowS Source #
Eq StructOrUnionSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source # (/=) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source #
Ord StructOrUnionSpecifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Ordering Source #

(<) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source #

(<=) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source #

(>) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source #

(>=) :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> Bool Source #

max :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> StructOrUnionSpecifier Source #

min :: StructOrUnionSpecifier -> StructOrUnionSpecifier -> StructOrUnionSpecifier Source #

Print StructOrUnionSpecifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> StructOrUnionSpecifier -> Doc Source #

data StructOrUnion Source #

Constructors

MkStructOrUnionStruct |
MkStructOrUnionUnion |

#### Instances

Instances details

Read StructOrUnion Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS StructOrUnion Source # readList :: ReadS [StructOrUnion] Source # readPrec :: ReadPrec StructOrUnion Source # readListPrec :: ReadPrec [StructOrUnion] Source #
Show StructOrUnion Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> StructOrUnion -> ShowS Source # show :: StructOrUnion -> String Source # showList :: [StructOrUnion] -> ShowS Source #
Eq StructOrUnion Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: StructOrUnion -> StructOrUnion -> Bool Source # (/=) :: StructOrUnion -> StructOrUnion -> Bool Source #
Ord StructOrUnion Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: StructOrUnion -> StructOrUnion -> Ordering Source #

(<) :: StructOrUnion -> StructOrUnion -> Bool Source #

(<=) :: StructOrUnion -> StructOrUnion -> Bool Source #

(>) :: StructOrUnion -> StructOrUnion -> Bool Source #

(>=) :: StructOrUnion -> StructOrUnion -> Bool Source #

max :: StructOrUnion -> StructOrUnion -> StructOrUnion Source #

min :: StructOrUnion -> StructOrUnion -> StructOrUnion Source #

Print StructOrUnion Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> StructOrUnion -> Doc Source #

data InitDeclarationListOpt Source #

Constructors

MkInitDeclarationListOptNothing |
MkInitDeclarationListOptJust [InitDeclarator] |

#### Instances

Instances details

Read InitDeclarationListOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS InitDeclarationListOpt Source # readList :: ReadS [InitDeclarationListOpt] Source # readPrec :: ReadPrec InitDeclarationListOpt Source # readListPrec :: ReadPrec [InitDeclarationListOpt] Source #
Show InitDeclarationListOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> InitDeclarationListOpt -> ShowS Source # show :: InitDeclarationListOpt -> String Source # showList :: [InitDeclarationListOpt] -> ShowS Source #
Eq InitDeclarationListOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source # (/=) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source #
Ord InitDeclarationListOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: InitDeclarationListOpt -> InitDeclarationListOpt -> Ordering Source #

(<) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source #

(<=) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source #

(>) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source #

(>=) :: InitDeclarationListOpt -> InitDeclarationListOpt -> Bool Source #

max :: InitDeclarationListOpt -> InitDeclarationListOpt -> InitDeclarationListOpt Source #

min :: InitDeclarationListOpt -> InitDeclarationListOpt -> InitDeclarationListOpt Source #

Print InitDeclarationListOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> InitDeclarationListOpt -> Doc Source #

data InitDeclarator Source #

Constructors

MkInitDeclaratorUninitialized Declarator |
MkInitDeclaratorInitialized Declarator Initializer |

#### Instances

Instances details

Read InitDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS InitDeclarator Source # readList :: ReadS [InitDeclarator] Source # readPrec :: ReadPrec InitDeclarator Source # readListPrec :: ReadPrec [InitDeclarator] Source #
Show InitDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> InitDeclarator -> ShowS Source # show :: InitDeclarator -> String Source # showList :: [InitDeclarator] -> ShowS Source #
Eq InitDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: InitDeclarator -> InitDeclarator -> Bool Source # (/=) :: InitDeclarator -> InitDeclarator -> Bool Source #
Ord InitDeclarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: InitDeclarator -> InitDeclarator -> Ordering Source #

(<) :: InitDeclarator -> InitDeclarator -> Bool Source #

(<=) :: InitDeclarator -> InitDeclarator -> Bool Source #

(>) :: InitDeclarator -> InitDeclarator -> Bool Source #

(>=) :: InitDeclarator -> InitDeclarator -> Bool Source #

max :: InitDeclarator -> InitDeclarator -> InitDeclarator Source #

min :: InitDeclarator -> InitDeclarator -> InitDeclarator Source #

Print InitDeclarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> InitDeclarator -> Doc Source #
Print [InitDeclarator] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [InitDeclarator] -> Doc Source #

data StructDeclaration Source #

Constructors

MkStructDeclaration [SpecifierQualifier] [StructDeclarator] |

#### Instances

Instances details

Read StructDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS StructDeclaration Source # readList :: ReadS [StructDeclaration] Source # readPrec :: ReadPrec StructDeclaration Source # readListPrec :: ReadPrec [StructDeclaration] Source #
Show StructDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> StructDeclaration -> ShowS Source # show :: StructDeclaration -> String Source # showList :: [StructDeclaration] -> ShowS Source #
Eq StructDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: StructDeclaration -> StructDeclaration -> Bool Source # (/=) :: StructDeclaration -> StructDeclaration -> Bool Source #
Ord StructDeclaration Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: StructDeclaration -> StructDeclaration -> Ordering Source #

(<) :: StructDeclaration -> StructDeclaration -> Bool Source #

(<=) :: StructDeclaration -> StructDeclaration -> Bool Source #

(>) :: StructDeclaration -> StructDeclaration -> Bool Source #

(>=) :: StructDeclaration -> StructDeclaration -> Bool Source #

max :: StructDeclaration -> StructDeclaration -> StructDeclaration Source #

min :: StructDeclaration -> StructDeclaration -> StructDeclaration Source #

Print StructDeclaration Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> StructDeclaration -> Doc Source #
Print [StructDeclaration] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [StructDeclaration] -> Doc Source #

data SpecifierQualifier Source #

Constructors

MkSpecifierQualifierTypeSpecifier TypeSpecifier |
MkSpecifierQualifierTypeQualifier TypeQualifier |

#### Instances

Instances details

Read SpecifierQualifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS SpecifierQualifier Source # readList :: ReadS [SpecifierQualifier] Source # readPrec :: ReadPrec SpecifierQualifier Source # readListPrec :: ReadPrec [SpecifierQualifier] Source #
Show SpecifierQualifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> SpecifierQualifier -> ShowS Source # show :: SpecifierQualifier -> String Source # showList :: [SpecifierQualifier] -> ShowS Source #
Eq SpecifierQualifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source # (/=) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source #
Ord SpecifierQualifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: SpecifierQualifier -> SpecifierQualifier -> Ordering Source #

(<) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source #

(<=) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source #

(>) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source #

(>=) :: SpecifierQualifier -> SpecifierQualifier -> Bool Source #

max :: SpecifierQualifier -> SpecifierQualifier -> SpecifierQualifier Source #

min :: SpecifierQualifier -> SpecifierQualifier -> SpecifierQualifier Source #

Print SpecifierQualifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> SpecifierQualifier -> Doc Source #
Print [SpecifierQualifier] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [SpecifierQualifier] -> Doc Source #

data StructDeclarator Source #

Constructors

MkStructDeclaratorDeclarator Declarator |
MkStructDeclaratorConstant DeclaratorOpt ConstantExpression |

#### Instances

Instances details

Read StructDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS StructDeclarator Source # readList :: ReadS [StructDeclarator] Source # readPrec :: ReadPrec StructDeclarator Source # readListPrec :: ReadPrec [StructDeclarator] Source #
Show StructDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> StructDeclarator -> ShowS Source # show :: StructDeclarator -> String Source # showList :: [StructDeclarator] -> ShowS Source #
Eq StructDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: StructDeclarator -> StructDeclarator -> Bool Source # (/=) :: StructDeclarator -> StructDeclarator -> Bool Source #
Ord StructDeclarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: StructDeclarator -> StructDeclarator -> Ordering Source #

(<) :: StructDeclarator -> StructDeclarator -> Bool Source #

(<=) :: StructDeclarator -> StructDeclarator -> Bool Source #

(>) :: StructDeclarator -> StructDeclarator -> Bool Source #

(>=) :: StructDeclarator -> StructDeclarator -> Bool Source #

max :: StructDeclarator -> StructDeclarator -> StructDeclarator Source #

min :: StructDeclarator -> StructDeclarator -> StructDeclarator Source #

Print StructDeclarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> StructDeclarator -> Doc Source #
Print [StructDeclarator] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [StructDeclarator] -> Doc Source #

data EnumSpecifier Source #

Constructors

MkEnumSpecifierWithCases IdentifierOpt EnumeratorList |
MkEnumSpecifierEmpty Identifier |

#### Instances

Instances details

Read EnumSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS EnumSpecifier Source # readList :: ReadS [EnumSpecifier] Source # readPrec :: ReadPrec EnumSpecifier Source # readListPrec :: ReadPrec [EnumSpecifier] Source #
Show EnumSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> EnumSpecifier -> ShowS Source # show :: EnumSpecifier -> String Source # showList :: [EnumSpecifier] -> ShowS Source #
Eq EnumSpecifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: EnumSpecifier -> EnumSpecifier -> Bool Source # (/=) :: EnumSpecifier -> EnumSpecifier -> Bool Source #
Ord EnumSpecifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: EnumSpecifier -> EnumSpecifier -> Ordering Source #

(<) :: EnumSpecifier -> EnumSpecifier -> Bool Source #

(<=) :: EnumSpecifier -> EnumSpecifier -> Bool Source #

(>) :: EnumSpecifier -> EnumSpecifier -> Bool Source #

(>=) :: EnumSpecifier -> EnumSpecifier -> Bool Source #

max :: EnumSpecifier -> EnumSpecifier -> EnumSpecifier Source #

min :: EnumSpecifier -> EnumSpecifier -> EnumSpecifier Source #

Print EnumSpecifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> EnumSpecifier -> Doc Source #

data EnumeratorList Source #

Constructors

MkEnumeratorList1 Enumerator |
MkEnumeratorListN EnumeratorList Enumerator |

#### Instances

Instances details

Read EnumeratorList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS EnumeratorList Source # readList :: ReadS [EnumeratorList] Source # readPrec :: ReadPrec EnumeratorList Source # readListPrec :: ReadPrec [EnumeratorList] Source #
Show EnumeratorList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> EnumeratorList -> ShowS Source # show :: EnumeratorList -> String Source # showList :: [EnumeratorList] -> ShowS Source #
Eq EnumeratorList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: EnumeratorList -> EnumeratorList -> Bool Source # (/=) :: EnumeratorList -> EnumeratorList -> Bool Source #
Ord EnumeratorList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: EnumeratorList -> EnumeratorList -> Ordering Source #

(<) :: EnumeratorList -> EnumeratorList -> Bool Source #

(<=) :: EnumeratorList -> EnumeratorList -> Bool Source #

(>) :: EnumeratorList -> EnumeratorList -> Bool Source #

(>=) :: EnumeratorList -> EnumeratorList -> Bool Source #

max :: EnumeratorList -> EnumeratorList -> EnumeratorList Source #

min :: EnumeratorList -> EnumeratorList -> EnumeratorList Source #

Print EnumeratorList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> EnumeratorList -> Doc Source #

data Enumerator Source #

Constructors

MkEnumeratorUninitialized Identifier |
MkEnumeratorInitialized Identifier ConstantExpression |

#### Instances

Instances details

Read Enumerator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Enumerator Source # readList :: ReadS [Enumerator] Source # readPrec :: ReadPrec Enumerator Source # readListPrec :: ReadPrec [Enumerator] Source #
Show Enumerator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Enumerator -> ShowS Source # show :: Enumerator -> String Source # showList :: [Enumerator] -> ShowS Source #
Eq Enumerator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Enumerator -> Enumerator -> Bool Source # (/=) :: Enumerator -> Enumerator -> Bool Source #
Ord Enumerator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Enumerator -> Enumerator -> Ordering Source #

(<) :: Enumerator -> Enumerator -> Bool Source #

(<=) :: Enumerator -> Enumerator -> Bool Source #

(>) :: Enumerator -> Enumerator -> Bool Source #

(>=) :: Enumerator -> Enumerator -> Bool Source #

max :: Enumerator -> Enumerator -> Enumerator Source #

min :: Enumerator -> Enumerator -> Enumerator Source #

Print Enumerator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Enumerator -> Doc Source #

data DeclaratorOpt Source #

Constructors

MkDeclaratorOptNothing |
MkDeclaratorOptJust Declarator |

#### Instances

Instances details

Read DeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DeclaratorOpt Source # readList :: ReadS [DeclaratorOpt] Source # readPrec :: ReadPrec DeclaratorOpt Source # readListPrec :: ReadPrec [DeclaratorOpt] Source #
Show DeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DeclaratorOpt -> ShowS Source # show :: DeclaratorOpt -> String Source # showList :: [DeclaratorOpt] -> ShowS Source #
Eq DeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source # (/=) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source #
Ord DeclaratorOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DeclaratorOpt -> DeclaratorOpt -> Ordering Source #

(<) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source #

(<=) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source #

(>) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source #

(>=) :: DeclaratorOpt -> DeclaratorOpt -> Bool Source #

max :: DeclaratorOpt -> DeclaratorOpt -> DeclaratorOpt Source #

min :: DeclaratorOpt -> DeclaratorOpt -> DeclaratorOpt Source #

Print DeclaratorOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DeclaratorOpt -> Doc Source #

data Declarator Source #

Constructors

MkDeclarator PointerOpt DirectDeclarator |

#### Instances

Instances details

Read Declarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Declarator Source # readList :: ReadS [Declarator] Source # readPrec :: ReadPrec Declarator Source # readListPrec :: ReadPrec [Declarator] Source #
Show Declarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Declarator -> ShowS Source # show :: Declarator -> String Source # showList :: [Declarator] -> ShowS Source #
Eq Declarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Declarator -> Declarator -> Bool Source # (/=) :: Declarator -> Declarator -> Bool Source #
Ord Declarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Declarator -> Declarator -> Ordering Source #

(<) :: Declarator -> Declarator -> Bool Source #

(<=) :: Declarator -> Declarator -> Bool Source #

(>) :: Declarator -> Declarator -> Bool Source #

(>=) :: Declarator -> Declarator -> Bool Source #

max :: Declarator -> Declarator -> Declarator Source #

min :: Declarator -> Declarator -> Declarator Source #

Print Declarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Declarator -> Doc Source #

data DirectDeclarator Source #

Constructors

MkDirectDeclaratorIdentifier Identifier |
MkDirectDeclaratorParDeclarator Declarator |
MkDirectDeclaratorConstantExpressionOpt DirectDeclarator ConstantExpressionOpt |
MkDirectDeclaratorParameterTypeList DirectDeclarator ParameterTypeList |
MkDirectDeclaratorIdentifierListOpt DirectDeclarator IdentifierListOpt |

#### Instances

Instances details

Read DirectDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DirectDeclarator Source # readList :: ReadS [DirectDeclarator] Source # readPrec :: ReadPrec DirectDeclarator Source # readListPrec :: ReadPrec [DirectDeclarator] Source #
Show DirectDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DirectDeclarator -> ShowS Source # show :: DirectDeclarator -> String Source # showList :: [DirectDeclarator] -> ShowS Source #
Eq DirectDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DirectDeclarator -> DirectDeclarator -> Bool Source # (/=) :: DirectDeclarator -> DirectDeclarator -> Bool Source #
Ord DirectDeclarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DirectDeclarator -> DirectDeclarator -> Ordering Source #

(<) :: DirectDeclarator -> DirectDeclarator -> Bool Source #

(<=) :: DirectDeclarator -> DirectDeclarator -> Bool Source #

(>) :: DirectDeclarator -> DirectDeclarator -> Bool Source #

(>=) :: DirectDeclarator -> DirectDeclarator -> Bool Source #

max :: DirectDeclarator -> DirectDeclarator -> DirectDeclarator Source #

min :: DirectDeclarator -> DirectDeclarator -> DirectDeclarator Source #

Print DirectDeclarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DirectDeclarator -> Doc Source #

data PointerOpt Source #

Constructors

MkPointerOptNothing |
MkPointerOptJust Pointer |

#### Instances

Instances details

Read PointerOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS PointerOpt Source # readList :: ReadS [PointerOpt] Source # readPrec :: ReadPrec PointerOpt Source # readListPrec :: ReadPrec [PointerOpt] Source #
Show PointerOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> PointerOpt -> ShowS Source # show :: PointerOpt -> String Source # showList :: [PointerOpt] -> ShowS Source #
Eq PointerOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: PointerOpt -> PointerOpt -> Bool Source # (/=) :: PointerOpt -> PointerOpt -> Bool Source #
Ord PointerOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: PointerOpt -> PointerOpt -> Ordering Source #

(<) :: PointerOpt -> PointerOpt -> Bool Source #

(<=) :: PointerOpt -> PointerOpt -> Bool Source #

(>) :: PointerOpt -> PointerOpt -> Bool Source #

(>=) :: PointerOpt -> PointerOpt -> Bool Source #

max :: PointerOpt -> PointerOpt -> PointerOpt Source #

min :: PointerOpt -> PointerOpt -> PointerOpt Source #

Print PointerOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> PointerOpt -> Doc Source #

data Pointer Source #

Constructors

MkPointer1 TypeQualifierListOpt |
MkPointerN TypeQualifierListOpt Pointer |

#### Instances

Instances details

Read Pointer Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Pointer Source # readList :: ReadS [Pointer] Source # readPrec :: ReadPrec Pointer Source # readListPrec :: ReadPrec [Pointer] Source #
Show Pointer Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Pointer -> ShowS Source # show :: Pointer -> String Source # showList :: [Pointer] -> ShowS Source #
Eq Pointer Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Pointer -> Pointer -> Bool Source # (/=) :: Pointer -> Pointer -> Bool Source #
Ord Pointer Source # |
Instance details Defined in Language.C.AbsC Methods compare :: Pointer -> Pointer -> Ordering Source # (<) :: Pointer -> Pointer -> Bool Source # (<=) :: Pointer -> Pointer -> Bool Source # (>) :: Pointer -> Pointer -> Bool Source # (>=) :: Pointer -> Pointer -> Bool Source # max :: Pointer -> Pointer -> Pointer Source # min :: Pointer -> Pointer -> Pointer Source #
Print Pointer Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Pointer -> Doc Source #

data TypeQualifierListOpt Source #

Constructors

MkTypeQualifierListOptNothing |
MkTypeQualifierListOptJust TypeQualifierList |

#### Instances

Instances details

Read TypeQualifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TypeQualifierListOpt Source # readList :: ReadS [TypeQualifierListOpt] Source # readPrec :: ReadPrec TypeQualifierListOpt Source # readListPrec :: ReadPrec [TypeQualifierListOpt] Source #
Show TypeQualifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TypeQualifierListOpt -> ShowS Source # show :: TypeQualifierListOpt -> String Source # showList :: [TypeQualifierListOpt] -> ShowS Source #
Eq TypeQualifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source # (/=) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source #
Ord TypeQualifierListOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: TypeQualifierListOpt -> TypeQualifierListOpt -> Ordering Source #

(<) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source #

(<=) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source #

(>) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source #

(>=) :: TypeQualifierListOpt -> TypeQualifierListOpt -> Bool Source #

max :: TypeQualifierListOpt -> TypeQualifierListOpt -> TypeQualifierListOpt Source #

min :: TypeQualifierListOpt -> TypeQualifierListOpt -> TypeQualifierListOpt Source #

Print TypeQualifierListOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TypeQualifierListOpt -> Doc Source #

data TypeQualifierList Source #

Constructors

MkTypeQualifierList1 TypeQualifier |
MkTypeQualifierListN TypeQualifierList TypeQualifier |

#### Instances

Instances details

Read TypeQualifierList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TypeQualifierList Source # readList :: ReadS [TypeQualifierList] Source # readPrec :: ReadPrec TypeQualifierList Source # readListPrec :: ReadPrec [TypeQualifierList] Source #
Show TypeQualifierList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TypeQualifierList -> ShowS Source # show :: TypeQualifierList -> String Source # showList :: [TypeQualifierList] -> ShowS Source #
Eq TypeQualifierList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TypeQualifierList -> TypeQualifierList -> Bool Source # (/=) :: TypeQualifierList -> TypeQualifierList -> Bool Source #
Ord TypeQualifierList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: TypeQualifierList -> TypeQualifierList -> Ordering Source #

(<) :: TypeQualifierList -> TypeQualifierList -> Bool Source #

(<=) :: TypeQualifierList -> TypeQualifierList -> Bool Source #

(>) :: TypeQualifierList -> TypeQualifierList -> Bool Source #

(>=) :: TypeQualifierList -> TypeQualifierList -> Bool Source #

max :: TypeQualifierList -> TypeQualifierList -> TypeQualifierList Source #

min :: TypeQualifierList -> TypeQualifierList -> TypeQualifierList Source #

Print TypeQualifierList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TypeQualifierList -> Doc Source #

data ParameterTypeList Source #

Constructors

MkParameterTypeList ParameterList |
MkParameterTypeListEllipsis ParameterList |

#### Instances

Instances details

Read ParameterTypeList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ParameterTypeList Source # readList :: ReadS [ParameterTypeList] Source # readPrec :: ReadPrec ParameterTypeList Source # readListPrec :: ReadPrec [ParameterTypeList] Source #
Show ParameterTypeList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ParameterTypeList -> ShowS Source # show :: ParameterTypeList -> String Source # showList :: [ParameterTypeList] -> ShowS Source #
Eq ParameterTypeList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ParameterTypeList -> ParameterTypeList -> Bool Source # (/=) :: ParameterTypeList -> ParameterTypeList -> Bool Source #
Ord ParameterTypeList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ParameterTypeList -> ParameterTypeList -> Ordering Source #

(<) :: ParameterTypeList -> ParameterTypeList -> Bool Source #

(<=) :: ParameterTypeList -> ParameterTypeList -> Bool Source #

(>) :: ParameterTypeList -> ParameterTypeList -> Bool Source #

(>=) :: ParameterTypeList -> ParameterTypeList -> Bool Source #

max :: ParameterTypeList -> ParameterTypeList -> ParameterTypeList Source #

min :: ParameterTypeList -> ParameterTypeList -> ParameterTypeList Source #

Print ParameterTypeList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ParameterTypeList -> Doc Source #

data ParameterList Source #

Constructors

MkParameterList1 ParameterDeclaration |
MkParameterListN ParameterList ParameterDeclaration |

#### Instances

Instances details

Read ParameterList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ParameterList Source # readList :: ReadS [ParameterList] Source # readPrec :: ReadPrec ParameterList Source # readListPrec :: ReadPrec [ParameterList] Source #
Show ParameterList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ParameterList -> ShowS Source # show :: ParameterList -> String Source # showList :: [ParameterList] -> ShowS Source #
Eq ParameterList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ParameterList -> ParameterList -> Bool Source # (/=) :: ParameterList -> ParameterList -> Bool Source #
Ord ParameterList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ParameterList -> ParameterList -> Ordering Source #

(<) :: ParameterList -> ParameterList -> Bool Source #

(<=) :: ParameterList -> ParameterList -> Bool Source #

(>) :: ParameterList -> ParameterList -> Bool Source #

(>=) :: ParameterList -> ParameterList -> Bool Source #

max :: ParameterList -> ParameterList -> ParameterList Source #

min :: ParameterList -> ParameterList -> ParameterList Source #

Print ParameterList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ParameterList -> Doc Source #

data ParameterDeclaration Source #

Constructors

MkParameterDeclarationDeclarator DeclarationSpecifiers Declarator |
MkParameterDeclarationAbstractDeclaratorOpt DeclarationSpecifiers AbstractDeclaratorOpt |

#### Instances

Instances details

Read ParameterDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ParameterDeclaration Source # readList :: ReadS [ParameterDeclaration] Source # readPrec :: ReadPrec ParameterDeclaration Source # readListPrec :: ReadPrec [ParameterDeclaration] Source #
Show ParameterDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ParameterDeclaration -> ShowS Source # show :: ParameterDeclaration -> String Source # showList :: [ParameterDeclaration] -> ShowS Source #
Eq ParameterDeclaration Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source # (/=) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source #
Ord ParameterDeclaration Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ParameterDeclaration -> ParameterDeclaration -> Ordering Source #

(<) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source #

(<=) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source #

(>) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source #

(>=) :: ParameterDeclaration -> ParameterDeclaration -> Bool Source #

max :: ParameterDeclaration -> ParameterDeclaration -> ParameterDeclaration Source #

min :: ParameterDeclaration -> ParameterDeclaration -> ParameterDeclaration Source #

Print ParameterDeclaration Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ParameterDeclaration -> Doc Source #

data IdentifierListOpt Source #

Constructors

MkIdentifierListOptNothing |
MkIdentifierListOptJust IdentifierList |

#### Instances

Instances details

Read IdentifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS IdentifierListOpt Source # readList :: ReadS [IdentifierListOpt] Source # readPrec :: ReadPrec IdentifierListOpt Source # readListPrec :: ReadPrec [IdentifierListOpt] Source #
Show IdentifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> IdentifierListOpt -> ShowS Source # show :: IdentifierListOpt -> String Source # showList :: [IdentifierListOpt] -> ShowS Source #
Eq IdentifierListOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source # (/=) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source #
Ord IdentifierListOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: IdentifierListOpt -> IdentifierListOpt -> Ordering Source #

(<) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source #

(<=) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source #

(>) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source #

(>=) :: IdentifierListOpt -> IdentifierListOpt -> Bool Source #

max :: IdentifierListOpt -> IdentifierListOpt -> IdentifierListOpt Source #

min :: IdentifierListOpt -> IdentifierListOpt -> IdentifierListOpt Source #

Print IdentifierListOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> IdentifierListOpt -> Doc Source #

data IdentifierList Source #

Constructors

MkIdentifierList1 Identifier |
MkIdentifierListN IdentifierList Identifier |

#### Instances

Instances details

Read IdentifierList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS IdentifierList Source # readList :: ReadS [IdentifierList] Source # readPrec :: ReadPrec IdentifierList Source # readListPrec :: ReadPrec [IdentifierList] Source #
Show IdentifierList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> IdentifierList -> ShowS Source # show :: IdentifierList -> String Source # showList :: [IdentifierList] -> ShowS Source #
Eq IdentifierList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: IdentifierList -> IdentifierList -> Bool Source # (/=) :: IdentifierList -> IdentifierList -> Bool Source #
Ord IdentifierList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: IdentifierList -> IdentifierList -> Ordering Source #

(<) :: IdentifierList -> IdentifierList -> Bool Source #

(<=) :: IdentifierList -> IdentifierList -> Bool Source #

(>) :: IdentifierList -> IdentifierList -> Bool Source #

(>=) :: IdentifierList -> IdentifierList -> Bool Source #

max :: IdentifierList -> IdentifierList -> IdentifierList Source #

min :: IdentifierList -> IdentifierList -> IdentifierList Source #

Print IdentifierList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> IdentifierList -> Doc Source #

data Initializer Source #

Constructors

MkInitializerAssignment Expression |
MkInitializerIniutializerList InitializerList |
MkInitializerIniutializerListC InitializerList |

#### Instances

Instances details

Read Initializer Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Initializer Source # readList :: ReadS [Initializer] Source # readPrec :: ReadPrec Initializer Source # readListPrec :: ReadPrec [Initializer] Source #
Show Initializer Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Initializer -> ShowS Source # show :: Initializer -> String Source # showList :: [Initializer] -> ShowS Source #
Eq Initializer Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Initializer -> Initializer -> Bool Source # (/=) :: Initializer -> Initializer -> Bool Source #
Ord Initializer Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Initializer -> Initializer -> Ordering Source #

(<) :: Initializer -> Initializer -> Bool Source #

(<=) :: Initializer -> Initializer -> Bool Source #

(>) :: Initializer -> Initializer -> Bool Source #

(>=) :: Initializer -> Initializer -> Bool Source #

max :: Initializer -> Initializer -> Initializer Source #

min :: Initializer -> Initializer -> Initializer Source #

Print Initializer Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Initializer -> Doc Source #

data InitializerList Source #

Constructors

MkInitializerList1 Initializer |
MkInitializerListN InitializerList Initializer |

#### Instances

Instances details

Read InitializerList Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS InitializerList Source # readList :: ReadS [InitializerList] Source # readPrec :: ReadPrec InitializerList Source # readListPrec :: ReadPrec [InitializerList] Source #
Show InitializerList Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> InitializerList -> ShowS Source # show :: InitializerList -> String Source # showList :: [InitializerList] -> ShowS Source #
Eq InitializerList Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: InitializerList -> InitializerList -> Bool Source # (/=) :: InitializerList -> InitializerList -> Bool Source #
Ord InitializerList Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: InitializerList -> InitializerList -> Ordering Source #

(<) :: InitializerList -> InitializerList -> Bool Source #

(<=) :: InitializerList -> InitializerList -> Bool Source #

(>) :: InitializerList -> InitializerList -> Bool Source #

(>=) :: InitializerList -> InitializerList -> Bool Source #

max :: InitializerList -> InitializerList -> InitializerList Source #

min :: InitializerList -> InitializerList -> InitializerList Source #

Print InitializerList Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> InitializerList -> Doc Source #

data TypeName Source #

Constructors

MkTypeName [SpecifierQualifier] AbstractDeclaratorOpt |

#### Instances

Instances details

Read TypeName Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS TypeName Source # readList :: ReadS [TypeName] Source # readPrec :: ReadPrec TypeName Source # readListPrec :: ReadPrec [TypeName] Source #
Show TypeName Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> TypeName -> ShowS Source # show :: TypeName -> String Source # showList :: [TypeName] -> ShowS Source #
Eq TypeName Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: TypeName -> TypeName -> Bool Source # (/=) :: TypeName -> TypeName -> Bool Source #
Ord TypeName Source # |
Instance details Defined in Language.C.AbsC Methods compare :: TypeName -> TypeName -> Ordering Source # (<) :: TypeName -> TypeName -> Bool Source # (<=) :: TypeName -> TypeName -> Bool Source # (>) :: TypeName -> TypeName -> Bool Source # (>=) :: TypeName -> TypeName -> Bool Source # max :: TypeName -> TypeName -> TypeName Source # min :: TypeName -> TypeName -> TypeName Source #
Print TypeName Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> TypeName -> Doc Source #

data AbstractDeclaratorOpt Source #

Constructors

MkAbstractDeclaratorOptNothing |
MkAbstractDeclaratorOptJust AbstractDeclarator |

#### Instances

Instances details

Read AbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS AbstractDeclaratorOpt Source # readList :: ReadS [AbstractDeclaratorOpt] Source # readPrec :: ReadPrec AbstractDeclaratorOpt Source # readListPrec :: ReadPrec [AbstractDeclaratorOpt] Source #
Show AbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> AbstractDeclaratorOpt -> ShowS Source # show :: AbstractDeclaratorOpt -> String Source # showList :: [AbstractDeclaratorOpt] -> ShowS Source #
Eq AbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source # (/=) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source #
Ord AbstractDeclaratorOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Ordering Source #

(<) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source #

(<=) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source #

(>) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source #

(>=) :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> Bool Source #

max :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> AbstractDeclaratorOpt Source #

min :: AbstractDeclaratorOpt -> AbstractDeclaratorOpt -> AbstractDeclaratorOpt Source #

Print AbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> AbstractDeclaratorOpt -> Doc Source #

data AbstractDeclarator Source #

Constructors

MkAbstractDeclaratorPointer Pointer |
MkAbstractDeclaratorDirect PointerOpt DirectAbstractDeclarator |

#### Instances

Instances details

Read AbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS AbstractDeclarator Source # readList :: ReadS [AbstractDeclarator] Source # readPrec :: ReadPrec AbstractDeclarator Source # readListPrec :: ReadPrec [AbstractDeclarator] Source #
Show AbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> AbstractDeclarator -> ShowS Source # show :: AbstractDeclarator -> String Source # showList :: [AbstractDeclarator] -> ShowS Source #
Eq AbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source # (/=) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source #
Ord AbstractDeclarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: AbstractDeclarator -> AbstractDeclarator -> Ordering Source #

(<) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source #

(<=) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source #

(>) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source #

(>=) :: AbstractDeclarator -> AbstractDeclarator -> Bool Source #

max :: AbstractDeclarator -> AbstractDeclarator -> AbstractDeclarator Source #

min :: AbstractDeclarator -> AbstractDeclarator -> AbstractDeclarator Source #

Print AbstractDeclarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> AbstractDeclarator -> Doc Source #

data DirectAbstractDeclaratorOpt Source #

Constructors

MkDirectAbstractDeclaratorOptNothing |
MkDirectAbstractDeclaratorOptJust DirectAbstractDeclarator |

#### Instances

Instances details

Read DirectAbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DirectAbstractDeclaratorOpt Source # readList :: ReadS [DirectAbstractDeclaratorOpt] Source # readPrec :: ReadPrec DirectAbstractDeclaratorOpt Source # readListPrec :: ReadPrec [DirectAbstractDeclaratorOpt] Source #
Show DirectAbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DirectAbstractDeclaratorOpt -> ShowS Source # show :: DirectAbstractDeclaratorOpt -> String Source # showList :: [DirectAbstractDeclaratorOpt] -> ShowS Source #
Eq DirectAbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source # (/=) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source #
Ord DirectAbstractDeclaratorOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Ordering Source #

(<) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source #

(<=) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source #

(>) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source #

(>=) :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> Bool Source #

max :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt Source #

min :: DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt -> DirectAbstractDeclaratorOpt Source #

Print DirectAbstractDeclaratorOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DirectAbstractDeclaratorOpt -> Doc Source #

data DirectAbstractDeclarator Source #

Constructors

MkDirectAbstractDeclaratorPar AbstractDeclarator |
MkDirectAbstractDeclaratorConstantExpressionOpt DirectAbstractDeclaratorOpt ConstantExpressionOpt |
MkDirectAbstractDeclaratorParameterTypeList DirectAbstractDeclaratorOpt ParameterTypeList |

#### Instances

Instances details

Read DirectAbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS DirectAbstractDeclarator Source # readList :: ReadS [DirectAbstractDeclarator] Source # readPrec :: ReadPrec DirectAbstractDeclarator Source # readListPrec :: ReadPrec [DirectAbstractDeclarator] Source #
Show DirectAbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> DirectAbstractDeclarator -> ShowS Source # show :: DirectAbstractDeclarator -> String Source # showList :: [DirectAbstractDeclarator] -> ShowS Source #
Eq DirectAbstractDeclarator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source # (/=) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source #
Ord DirectAbstractDeclarator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Ordering Source #

(<) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source #

(<=) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source #

(>) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source #

(>=) :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> Bool Source #

max :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> DirectAbstractDeclarator Source #

min :: DirectAbstractDeclarator -> DirectAbstractDeclarator -> DirectAbstractDeclarator Source #

Print DirectAbstractDeclarator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> DirectAbstractDeclarator -> Doc Source #

data Statement Source #

Constructors

MkStatementLabeled LabeledStatement |
MkStatementExpression ExpressionStatement |
MkStatementCompound CompoundStatement |
MkStatementSelection SelectionStatement |
MkStatementIteration IterationStatement |
MkStatementJump JumpStatement |

#### Instances

Instances details

Read Statement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Statement Source # readList :: ReadS [Statement] Source # readPrec :: ReadPrec Statement Source # readListPrec :: ReadPrec [Statement] Source #
Show Statement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Statement -> ShowS Source # show :: Statement -> String Source # showList :: [Statement] -> ShowS Source #
Eq Statement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Statement -> Statement -> Bool Source # (/=) :: Statement -> Statement -> Bool Source #
Ord Statement Source # |
Instance details Defined in Language.C.AbsC Methods compare :: Statement -> Statement -> Ordering Source # (<) :: Statement -> Statement -> Bool Source # (<=) :: Statement -> Statement -> Bool Source # (>) :: Statement -> Statement -> Bool Source # (>=) :: Statement -> Statement -> Bool Source # max :: Statement -> Statement -> Statement Source # min :: Statement -> Statement -> Statement Source #
Print Statement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Statement -> Doc Source #
Print [Statement] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [Statement] -> Doc Source #

data LabeledStatement Source #

Constructors

MkLabeledStatementIdentifier Identifier Statement |
MkLabeledStatementCase ConstantExpression Statement |
MkLabeledStatementDefault Statement |

#### Instances

Instances details

Read LabeledStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS LabeledStatement Source # readList :: ReadS [LabeledStatement] Source # readPrec :: ReadPrec LabeledStatement Source # readListPrec :: ReadPrec [LabeledStatement] Source #
Show LabeledStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> LabeledStatement -> ShowS Source # show :: LabeledStatement -> String Source # showList :: [LabeledStatement] -> ShowS Source #
Eq LabeledStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: LabeledStatement -> LabeledStatement -> Bool Source # (/=) :: LabeledStatement -> LabeledStatement -> Bool Source #
Ord LabeledStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: LabeledStatement -> LabeledStatement -> Ordering Source #

(<) :: LabeledStatement -> LabeledStatement -> Bool Source #

(<=) :: LabeledStatement -> LabeledStatement -> Bool Source #

(>) :: LabeledStatement -> LabeledStatement -> Bool Source #

(>=) :: LabeledStatement -> LabeledStatement -> Bool Source #

max :: LabeledStatement -> LabeledStatement -> LabeledStatement Source #

min :: LabeledStatement -> LabeledStatement -> LabeledStatement Source #

Print LabeledStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> LabeledStatement -> Doc Source #

data ExpressionStatement Source #

Constructors

MkExpressionStatement ExpressionOpt |

#### Instances

Instances details

Read ExpressionStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ExpressionStatement Source # readList :: ReadS [ExpressionStatement] Source # readPrec :: ReadPrec ExpressionStatement Source # readListPrec :: ReadPrec [ExpressionStatement] Source #
Show ExpressionStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ExpressionStatement -> ShowS Source # show :: ExpressionStatement -> String Source # showList :: [ExpressionStatement] -> ShowS Source #
Eq ExpressionStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ExpressionStatement -> ExpressionStatement -> Bool Source # (/=) :: ExpressionStatement -> ExpressionStatement -> Bool Source #
Ord ExpressionStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ExpressionStatement -> ExpressionStatement -> Ordering Source #

(<) :: ExpressionStatement -> ExpressionStatement -> Bool Source #

(<=) :: ExpressionStatement -> ExpressionStatement -> Bool Source #

(>) :: ExpressionStatement -> ExpressionStatement -> Bool Source #

(>=) :: ExpressionStatement -> ExpressionStatement -> Bool Source #

max :: ExpressionStatement -> ExpressionStatement -> ExpressionStatement Source #

min :: ExpressionStatement -> ExpressionStatement -> ExpressionStatement Source #

Print ExpressionStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ExpressionStatement -> Doc Source #

data CompoundStatement Source #

Constructors

MkCompoundStatement [Declaration] [Statement] |

#### Instances

Instances details

Read CompoundStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS CompoundStatement Source # readList :: ReadS [CompoundStatement] Source # readPrec :: ReadPrec CompoundStatement Source # readListPrec :: ReadPrec [CompoundStatement] Source #
Show CompoundStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> CompoundStatement -> ShowS Source # show :: CompoundStatement -> String Source # showList :: [CompoundStatement] -> ShowS Source #
Eq CompoundStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: CompoundStatement -> CompoundStatement -> Bool Source # (/=) :: CompoundStatement -> CompoundStatement -> Bool Source #
Ord CompoundStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: CompoundStatement -> CompoundStatement -> Ordering Source #

(<) :: CompoundStatement -> CompoundStatement -> Bool Source #

(<=) :: CompoundStatement -> CompoundStatement -> Bool Source #

(>) :: CompoundStatement -> CompoundStatement -> Bool Source #

(>=) :: CompoundStatement -> CompoundStatement -> Bool Source #

max :: CompoundStatement -> CompoundStatement -> CompoundStatement Source #

min :: CompoundStatement -> CompoundStatement -> CompoundStatement Source #

Print CompoundStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> CompoundStatement -> Doc Source #

data SelectionStatement Source #

Constructors

MkSelectionStatementIfThen Expression Statement |
MkSelectionStatementIfThenElse Expression Statement Statement |
MkSelectionStatementSwitch Expression Statement |

#### Instances

Instances details

Read SelectionStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS SelectionStatement Source # readList :: ReadS [SelectionStatement] Source # readPrec :: ReadPrec SelectionStatement Source # readListPrec :: ReadPrec [SelectionStatement] Source #
Show SelectionStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> SelectionStatement -> ShowS Source # show :: SelectionStatement -> String Source # showList :: [SelectionStatement] -> ShowS Source #
Eq SelectionStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: SelectionStatement -> SelectionStatement -> Bool Source # (/=) :: SelectionStatement -> SelectionStatement -> Bool Source #
Ord SelectionStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: SelectionStatement -> SelectionStatement -> Ordering Source #

(<) :: SelectionStatement -> SelectionStatement -> Bool Source #

(<=) :: SelectionStatement -> SelectionStatement -> Bool Source #

(>) :: SelectionStatement -> SelectionStatement -> Bool Source #

(>=) :: SelectionStatement -> SelectionStatement -> Bool Source #

max :: SelectionStatement -> SelectionStatement -> SelectionStatement Source #

min :: SelectionStatement -> SelectionStatement -> SelectionStatement Source #

Print SelectionStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> SelectionStatement -> Doc Source #

data IterationStatement Source #

Constructors

MkIterationStatementWhile Expression Statement |
MkIterationStatementDo Statement Expression |
MkIterationStatementFor ExpressionOpt ExpressionOpt ExpressionOpt Statement |

#### Instances

Instances details

Read IterationStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS IterationStatement Source # readList :: ReadS [IterationStatement] Source # readPrec :: ReadPrec IterationStatement Source # readListPrec :: ReadPrec [IterationStatement] Source #
Show IterationStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> IterationStatement -> ShowS Source # show :: IterationStatement -> String Source # showList :: [IterationStatement] -> ShowS Source #
Eq IterationStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: IterationStatement -> IterationStatement -> Bool Source # (/=) :: IterationStatement -> IterationStatement -> Bool Source #
Ord IterationStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: IterationStatement -> IterationStatement -> Ordering Source #

(<) :: IterationStatement -> IterationStatement -> Bool Source #

(<=) :: IterationStatement -> IterationStatement -> Bool Source #

(>) :: IterationStatement -> IterationStatement -> Bool Source #

(>=) :: IterationStatement -> IterationStatement -> Bool Source #

max :: IterationStatement -> IterationStatement -> IterationStatement Source #

min :: IterationStatement -> IterationStatement -> IterationStatement Source #

Print IterationStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> IterationStatement -> Doc Source #

data JumpStatement Source #

Constructors

MkJumpStatementGoto Identifier |
MkJumpStatementContinue |
MkJumpStatementBreak |
MkJumpStatementReturn ExpressionOpt |

#### Instances

Instances details

Read JumpStatement Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS JumpStatement Source # readList :: ReadS [JumpStatement] Source # readPrec :: ReadPrec JumpStatement Source # readListPrec :: ReadPrec [JumpStatement] Source #
Show JumpStatement Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> JumpStatement -> ShowS Source # show :: JumpStatement -> String Source # showList :: [JumpStatement] -> ShowS Source #
Eq JumpStatement Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: JumpStatement -> JumpStatement -> Bool Source # (/=) :: JumpStatement -> JumpStatement -> Bool Source #
Ord JumpStatement Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: JumpStatement -> JumpStatement -> Ordering Source #

(<) :: JumpStatement -> JumpStatement -> Bool Source #

(<=) :: JumpStatement -> JumpStatement -> Bool Source #

(>) :: JumpStatement -> JumpStatement -> Bool Source #

(>=) :: JumpStatement -> JumpStatement -> Bool Source #

max :: JumpStatement -> JumpStatement -> JumpStatement Source #

min :: JumpStatement -> JumpStatement -> JumpStatement Source #

Print JumpStatement Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> JumpStatement -> Doc Source #

data ExpressionOpt Source #

Constructors

MkExpressionOptNothing |
MkExpressionOptJust Expression |

#### Instances

Instances details

Read ExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ExpressionOpt Source # readList :: ReadS [ExpressionOpt] Source # readPrec :: ReadPrec ExpressionOpt Source # readListPrec :: ReadPrec [ExpressionOpt] Source #
Show ExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ExpressionOpt -> ShowS Source # show :: ExpressionOpt -> String Source # showList :: [ExpressionOpt] -> ShowS Source #
Eq ExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ExpressionOpt -> ExpressionOpt -> Bool Source # (/=) :: ExpressionOpt -> ExpressionOpt -> Bool Source #
Ord ExpressionOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ExpressionOpt -> ExpressionOpt -> Ordering Source #

(<) :: ExpressionOpt -> ExpressionOpt -> Bool Source #

(<=) :: ExpressionOpt -> ExpressionOpt -> Bool Source #

(>) :: ExpressionOpt -> ExpressionOpt -> Bool Source #

(>=) :: ExpressionOpt -> ExpressionOpt -> Bool Source #

max :: ExpressionOpt -> ExpressionOpt -> ExpressionOpt Source #

min :: ExpressionOpt -> ExpressionOpt -> ExpressionOpt Source #

Print ExpressionOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ExpressionOpt -> Doc Source #

data Expression Source #

Constructors

Expression12 CastExpression |
Expression11 Expression MultOp Expression |
Expression10 Expression AddOp Expression |
Expression9 Expression ShiftOp Expression |
Expression8 Expression RelOp Expression |
Expression7 Expression EqOp Expression |
Expression6 Expression Expression |
Expression5 Expression Expression |
Expression4 Expression Expression |
Expression3 Expression Expression |
Expression2 Expression Expression Expression |
Expression1 UnaryExpression AssignmentOperator Expression |
Expression Expression Expression |

#### Instances

Instances details

Read Expression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Expression Source # readList :: ReadS [Expression] Source # readPrec :: ReadPrec Expression Source # readListPrec :: ReadPrec [Expression] Source #
Show Expression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Expression -> ShowS Source # show :: Expression -> String Source # showList :: [Expression] -> ShowS Source #
Eq Expression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Expression -> Expression -> Bool Source # (/=) :: Expression -> Expression -> Bool Source #
Ord Expression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Expression -> Expression -> Ordering Source #

(<) :: Expression -> Expression -> Bool Source #

(<=) :: Expression -> Expression -> Bool Source #

(>) :: Expression -> Expression -> Bool Source #

(>=) :: Expression -> Expression -> Bool Source #

max :: Expression -> Expression -> Expression Source #

min :: Expression -> Expression -> Expression Source #

Print Expression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Expression -> Doc Source #
Print [Expression] Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> [Expression] -> Doc Source #

data AssignmentOperator Source #

Constructors

MkAssignmentOperatorAssign |
MkAssignmentOperatorTimes |
MkAssignmentOperatorDiv |
MkAssignmentOperatorMod |
MkAssignmentOperatorPlus |
MkAssignmentOperatorMinus |
MkAssignmentOperatorShiftL |
MkAssignmentOperatorShiftR |
MkAssignmentOperatorAnd |
MkAssignmentOperatorXOr |
MkAssignmentOperatorOr |

#### Instances

Instances details

Read AssignmentOperator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS AssignmentOperator Source # readList :: ReadS [AssignmentOperator] Source # readPrec :: ReadPrec AssignmentOperator Source # readListPrec :: ReadPrec [AssignmentOperator] Source #
Show AssignmentOperator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> AssignmentOperator -> ShowS Source # show :: AssignmentOperator -> String Source # showList :: [AssignmentOperator] -> ShowS Source #
Eq AssignmentOperator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: AssignmentOperator -> AssignmentOperator -> Bool Source # (/=) :: AssignmentOperator -> AssignmentOperator -> Bool Source #
Ord AssignmentOperator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: AssignmentOperator -> AssignmentOperator -> Ordering Source #

(<) :: AssignmentOperator -> AssignmentOperator -> Bool Source #

(<=) :: AssignmentOperator -> AssignmentOperator -> Bool Source #

(>) :: AssignmentOperator -> AssignmentOperator -> Bool Source #

(>=) :: AssignmentOperator -> AssignmentOperator -> Bool Source #

max :: AssignmentOperator -> AssignmentOperator -> AssignmentOperator Source #

min :: AssignmentOperator -> AssignmentOperator -> AssignmentOperator Source #

Print AssignmentOperator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> AssignmentOperator -> Doc Source #

data ConstantExpressionOpt Source #

Constructors

MkConditionalExpressionNothing |
MkConditionalExpressionJust ConstantExpression |

#### Instances

Instances details

Read ConstantExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ConstantExpressionOpt Source # readList :: ReadS [ConstantExpressionOpt] Source # readPrec :: ReadPrec ConstantExpressionOpt Source # readListPrec :: ReadPrec [ConstantExpressionOpt] Source #
Show ConstantExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ConstantExpressionOpt -> ShowS Source # show :: ConstantExpressionOpt -> String Source # showList :: [ConstantExpressionOpt] -> ShowS Source #
Eq ConstantExpressionOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source # (/=) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source #
Ord ConstantExpressionOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ConstantExpressionOpt -> ConstantExpressionOpt -> Ordering Source #

(<) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source #

(<=) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source #

(>) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source #

(>=) :: ConstantExpressionOpt -> ConstantExpressionOpt -> Bool Source #

max :: ConstantExpressionOpt -> ConstantExpressionOpt -> ConstantExpressionOpt Source #

min :: ConstantExpressionOpt -> ConstantExpressionOpt -> ConstantExpressionOpt Source #

Print ConstantExpressionOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ConstantExpressionOpt -> Doc Source #

data ConstantExpression Source #

Constructors

MkConstantExpression Expression |

#### Instances

Instances details

Read ConstantExpression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ConstantExpression Source # readList :: ReadS [ConstantExpression] Source # readPrec :: ReadPrec ConstantExpression Source # readListPrec :: ReadPrec [ConstantExpression] Source #
Show ConstantExpression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ConstantExpression -> ShowS Source # show :: ConstantExpression -> String Source # showList :: [ConstantExpression] -> ShowS Source #
Eq ConstantExpression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ConstantExpression -> ConstantExpression -> Bool Source # (/=) :: ConstantExpression -> ConstantExpression -> Bool Source #
Ord ConstantExpression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ConstantExpression -> ConstantExpression -> Ordering Source #

(<) :: ConstantExpression -> ConstantExpression -> Bool Source #

(<=) :: ConstantExpression -> ConstantExpression -> Bool Source #

(>) :: ConstantExpression -> ConstantExpression -> Bool Source #

(>=) :: ConstantExpression -> ConstantExpression -> Bool Source #

max :: ConstantExpression -> ConstantExpression -> ConstantExpression Source #

min :: ConstantExpression -> ConstantExpression -> ConstantExpression Source #

Print ConstantExpression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ConstantExpression -> Doc Source #

data EqOp Source #

Constructors

EqOpEq |
EqOpNeq |

#### Instances

Instances details

Read EqOp Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS EqOp Source # readList :: ReadS [EqOp] Source # readPrec :: ReadPrec EqOp Source # readListPrec :: ReadPrec [EqOp] Source #
Show EqOp Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> EqOp -> ShowS Source # show :: EqOp -> String Source # showList :: [EqOp] -> ShowS Source #
Eq EqOp Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: EqOp -> EqOp -> Bool Source # (/=) :: EqOp -> EqOp -> Bool Source #
Ord EqOp Source # |
Instance details Defined in Language.C.AbsC Methods compare :: EqOp -> EqOp -> Ordering Source # (<) :: EqOp -> EqOp -> Bool Source # (<=) :: EqOp -> EqOp -> Bool Source # (>) :: EqOp -> EqOp -> Bool Source # (>=) :: EqOp -> EqOp -> Bool Source # max :: EqOp -> EqOp -> EqOp Source # min :: EqOp -> EqOp -> EqOp Source #
Print EqOp Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> EqOp -> Doc Source #

data RelOp Source #

Constructors

RelOpLT |
RelOpGT |
RelOpLE |
RelOpGE |

#### Instances

Instances details

Read RelOp Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS RelOp Source # readList :: ReadS [RelOp] Source # readPrec :: ReadPrec RelOp Source # readListPrec :: ReadPrec [RelOp] Source #
Show RelOp Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> RelOp -> ShowS Source # show :: RelOp -> String Source # showList :: [RelOp] -> ShowS Source #
Eq RelOp Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: RelOp -> RelOp -> Bool Source # (/=) :: RelOp -> RelOp -> Bool Source #
Ord RelOp Source # |
Instance details Defined in Language.C.AbsC Methods compare :: RelOp -> RelOp -> Ordering Source # (<) :: RelOp -> RelOp -> Bool Source # (<=) :: RelOp -> RelOp -> Bool Source # (>) :: RelOp -> RelOp -> Bool Source # (>=) :: RelOp -> RelOp -> Bool Source # max :: RelOp -> RelOp -> RelOp Source # min :: RelOp -> RelOp -> RelOp Source #
Print RelOp Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> RelOp -> Doc Source #

data ShiftOp Source #

Constructors

ShiftOpLeft |
ShiftOpRight |

#### Instances

Instances details

Read ShiftOp Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ShiftOp Source # readList :: ReadS [ShiftOp] Source # readPrec :: ReadPrec ShiftOp Source # readListPrec :: ReadPrec [ShiftOp] Source #
Show ShiftOp Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ShiftOp -> ShowS Source # show :: ShiftOp -> String Source # showList :: [ShiftOp] -> ShowS Source #
Eq ShiftOp Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ShiftOp -> ShiftOp -> Bool Source # (/=) :: ShiftOp -> ShiftOp -> Bool Source #
Ord ShiftOp Source # |
Instance details Defined in Language.C.AbsC Methods compare :: ShiftOp -> ShiftOp -> Ordering Source # (<) :: ShiftOp -> ShiftOp -> Bool Source # (<=) :: ShiftOp -> ShiftOp -> Bool Source # (>) :: ShiftOp -> ShiftOp -> Bool Source # (>=) :: ShiftOp -> ShiftOp -> Bool Source # max :: ShiftOp -> ShiftOp -> ShiftOp Source # min :: ShiftOp -> ShiftOp -> ShiftOp Source #
Print ShiftOp Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ShiftOp -> Doc Source #

data AddOp Source #

Constructors

AddOpPlus |
AddOpMinus |

#### Instances

Instances details

Read AddOp Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS AddOp Source # readList :: ReadS [AddOp] Source # readPrec :: ReadPrec AddOp Source # readListPrec :: ReadPrec [AddOp] Source #
Show AddOp Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> AddOp -> ShowS Source # show :: AddOp -> String Source # showList :: [AddOp] -> ShowS Source #
Eq AddOp Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: AddOp -> AddOp -> Bool Source # (/=) :: AddOp -> AddOp -> Bool Source #
Ord AddOp Source # |
Instance details Defined in Language.C.AbsC Methods compare :: AddOp -> AddOp -> Ordering Source # (<) :: AddOp -> AddOp -> Bool Source # (<=) :: AddOp -> AddOp -> Bool Source # (>) :: AddOp -> AddOp -> Bool Source # (>=) :: AddOp -> AddOp -> Bool Source # max :: AddOp -> AddOp -> AddOp Source # min :: AddOp -> AddOp -> AddOp Source #
Print AddOp Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> AddOp -> Doc Source #

data MultOp Source #

Constructors

MultOpTimes |
MultOpDiv |
MultOpMod |

#### Instances

Instances details

Read MultOp Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS MultOp Source # readList :: ReadS [MultOp] Source # readPrec :: ReadPrec MultOp Source # readListPrec :: ReadPrec [MultOp] Source #
Show MultOp Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> MultOp -> ShowS Source # show :: MultOp -> String Source # showList :: [MultOp] -> ShowS Source #
Eq MultOp Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: MultOp -> MultOp -> Bool Source # (/=) :: MultOp -> MultOp -> Bool Source #
Ord MultOp Source # |
Instance details Defined in Language.C.AbsC Methods compare :: MultOp -> MultOp -> Ordering Source # (<) :: MultOp -> MultOp -> Bool Source # (<=) :: MultOp -> MultOp -> Bool Source # (>) :: MultOp -> MultOp -> Bool Source # (>=) :: MultOp -> MultOp -> Bool Source # max :: MultOp -> MultOp -> MultOp Source # min :: MultOp -> MultOp -> MultOp Source #
Print MultOp Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> MultOp -> Doc Source #

data CastExpression Source #

Constructors

MkCastExpression1 UnaryExpression |
MkCastExpressionN TypeName CastExpression |

#### Instances

Instances details

Read CastExpression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS CastExpression Source # readList :: ReadS [CastExpression] Source # readPrec :: ReadPrec CastExpression Source # readListPrec :: ReadPrec [CastExpression] Source #
Show CastExpression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> CastExpression -> ShowS Source # show :: CastExpression -> String Source # showList :: [CastExpression] -> ShowS Source #
Eq CastExpression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: CastExpression -> CastExpression -> Bool Source # (/=) :: CastExpression -> CastExpression -> Bool Source #
Ord CastExpression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: CastExpression -> CastExpression -> Ordering Source #

(<) :: CastExpression -> CastExpression -> Bool Source #

(<=) :: CastExpression -> CastExpression -> Bool Source #

(>) :: CastExpression -> CastExpression -> Bool Source #

(>=) :: CastExpression -> CastExpression -> Bool Source #

max :: CastExpression -> CastExpression -> CastExpression Source #

min :: CastExpression -> CastExpression -> CastExpression Source #

Print CastExpression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> CastExpression -> Doc Source #

data UnaryExpression Source #

Constructors

MkUnaryExpressionPostfix PostfixExpression |
MkUnaryExpressionPlus2 UnaryExpression |
MkUnaryExpressionMinus2 UnaryExpression |
MkUnaryExpressionUnaryOp UnaryOperator CastExpression |
MkUnaryExpressionSizeof1 UnaryExpression |
MkUnaryExpressionSizeofPar TypeName |

#### Instances

Instances details

Read UnaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS UnaryExpression Source # readList :: ReadS [UnaryExpression] Source # readPrec :: ReadPrec UnaryExpression Source # readListPrec :: ReadPrec [UnaryExpression] Source #
Show UnaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> UnaryExpression -> ShowS Source # show :: UnaryExpression -> String Source # showList :: [UnaryExpression] -> ShowS Source #
Eq UnaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: UnaryExpression -> UnaryExpression -> Bool Source # (/=) :: UnaryExpression -> UnaryExpression -> Bool Source #
Ord UnaryExpression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: UnaryExpression -> UnaryExpression -> Ordering Source #

(<) :: UnaryExpression -> UnaryExpression -> Bool Source #

(<=) :: UnaryExpression -> UnaryExpression -> Bool Source #

(>) :: UnaryExpression -> UnaryExpression -> Bool Source #

(>=) :: UnaryExpression -> UnaryExpression -> Bool Source #

max :: UnaryExpression -> UnaryExpression -> UnaryExpression Source #

min :: UnaryExpression -> UnaryExpression -> UnaryExpression Source #

Print UnaryExpression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> UnaryExpression -> Doc Source #

data UnaryOperator Source #

Constructors

MkUnaryOperatorAnd |
MkUnaryOperatorTimes |
MkUnaryOperatorPlus |
MkUnaryOperatorMinus |
MkUnaryOperatorTilde |
MkUnaryOperatorBang |

#### Instances

Instances details

Read UnaryOperator Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS UnaryOperator Source # readList :: ReadS [UnaryOperator] Source # readPrec :: ReadPrec UnaryOperator Source # readListPrec :: ReadPrec [UnaryOperator] Source #
Show UnaryOperator Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> UnaryOperator -> ShowS Source # show :: UnaryOperator -> String Source # showList :: [UnaryOperator] -> ShowS Source #
Eq UnaryOperator Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: UnaryOperator -> UnaryOperator -> Bool Source # (/=) :: UnaryOperator -> UnaryOperator -> Bool Source #
Ord UnaryOperator Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: UnaryOperator -> UnaryOperator -> Ordering Source #

(<) :: UnaryOperator -> UnaryOperator -> Bool Source #

(<=) :: UnaryOperator -> UnaryOperator -> Bool Source #

(>) :: UnaryOperator -> UnaryOperator -> Bool Source #

(>=) :: UnaryOperator -> UnaryOperator -> Bool Source #

max :: UnaryOperator -> UnaryOperator -> UnaryOperator Source #

min :: UnaryOperator -> UnaryOperator -> UnaryOperator Source #

Print UnaryOperator Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> UnaryOperator -> Doc Source #

data PostfixExpression Source #

Constructors

MkPostfixExpression1 PrimaryExpression |
MkPostfixExpressionBrackets PostfixExpression Expression |
MkPostfixExpressionArgumentExpressionListOpt PostfixExpression ArgumentExpressionListOpt |
MkPostfixExpressionDot PostfixExpression Identifier |
MkPostfixExpressionArrow PostfixExpression Identifier |
MkPostfixExpressionPlus2 PostfixExpression |
MkPostfixExpressionMinus2 PostfixExpression |

#### Instances

Instances details

Read PostfixExpression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS PostfixExpression Source # readList :: ReadS [PostfixExpression] Source # readPrec :: ReadPrec PostfixExpression Source # readListPrec :: ReadPrec [PostfixExpression] Source #
Show PostfixExpression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> PostfixExpression -> ShowS Source # show :: PostfixExpression -> String Source # showList :: [PostfixExpression] -> ShowS Source #
Eq PostfixExpression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: PostfixExpression -> PostfixExpression -> Bool Source # (/=) :: PostfixExpression -> PostfixExpression -> Bool Source #
Ord PostfixExpression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: PostfixExpression -> PostfixExpression -> Ordering Source #

(<) :: PostfixExpression -> PostfixExpression -> Bool Source #

(<=) :: PostfixExpression -> PostfixExpression -> Bool Source #

(>) :: PostfixExpression -> PostfixExpression -> Bool Source #

(>=) :: PostfixExpression -> PostfixExpression -> Bool Source #

max :: PostfixExpression -> PostfixExpression -> PostfixExpression Source #

min :: PostfixExpression -> PostfixExpression -> PostfixExpression Source #

Print PostfixExpression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> PostfixExpression -> Doc Source #

data PrimaryExpression Source #

Constructors

MkPrimaryExpressionIdentifier Identifier |
MkPrimaryExpressionConstant Constant |
MkPrimaryExpressionString String |
MkPrimaryExpressionParExpression Expression |

#### Instances

Instances details

Read PrimaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS PrimaryExpression Source # readList :: ReadS [PrimaryExpression] Source # readPrec :: ReadPrec PrimaryExpression Source # readListPrec :: ReadPrec [PrimaryExpression] Source #
Show PrimaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> PrimaryExpression -> ShowS Source # show :: PrimaryExpression -> String Source # showList :: [PrimaryExpression] -> ShowS Source #
Eq PrimaryExpression Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: PrimaryExpression -> PrimaryExpression -> Bool Source # (/=) :: PrimaryExpression -> PrimaryExpression -> Bool Source #
Ord PrimaryExpression Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: PrimaryExpression -> PrimaryExpression -> Ordering Source #

(<) :: PrimaryExpression -> PrimaryExpression -> Bool Source #

(<=) :: PrimaryExpression -> PrimaryExpression -> Bool Source #

(>) :: PrimaryExpression -> PrimaryExpression -> Bool Source #

(>=) :: PrimaryExpression -> PrimaryExpression -> Bool Source #

max :: PrimaryExpression -> PrimaryExpression -> PrimaryExpression Source #

min :: PrimaryExpression -> PrimaryExpression -> PrimaryExpression Source #

Print PrimaryExpression Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> PrimaryExpression -> Doc Source #

data ArgumentExpressionListOpt Source #

Constructors

MkArgumentExpressionListOptNothing |
MkArgumentExpressionListOptJust [Expression] |

#### Instances

Instances details

Read ArgumentExpressionListOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS ArgumentExpressionListOpt Source # readList :: ReadS [ArgumentExpressionListOpt] Source # readPrec :: ReadPrec ArgumentExpressionListOpt Source # readListPrec :: ReadPrec [ArgumentExpressionListOpt] Source #
Show ArgumentExpressionListOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> ArgumentExpressionListOpt -> ShowS Source # show :: ArgumentExpressionListOpt -> String Source # showList :: [ArgumentExpressionListOpt] -> ShowS Source #
Eq ArgumentExpressionListOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source # (/=) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source #
Ord ArgumentExpressionListOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Ordering Source #

(<) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source #

(<=) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source #

(>) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source #

(>=) :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> Bool Source #

max :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> ArgumentExpressionListOpt Source #

min :: ArgumentExpressionListOpt -> ArgumentExpressionListOpt -> ArgumentExpressionListOpt Source #

Print ArgumentExpressionListOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> ArgumentExpressionListOpt -> Doc Source #

data Constant Source #

Constructors

MkConstantInteger IntegerConstant |
MkConstantCharacter CharacterConstant |
MkConstantFloating FloatingConstant |

#### Instances

Instances details

Read Constant Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Constant Source # readList :: ReadS [Constant] Source # readPrec :: ReadPrec Constant Source # readListPrec :: ReadPrec [Constant] Source #
Show Constant Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Constant -> ShowS Source # show :: Constant -> String Source # showList :: [Constant] -> ShowS Source #
Eq Constant Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Constant -> Constant -> Bool Source # (/=) :: Constant -> Constant -> Bool Source #
Ord Constant Source # |
Instance details Defined in Language.C.AbsC Methods compare :: Constant -> Constant -> Ordering Source # (<) :: Constant -> Constant -> Bool Source # (<=) :: Constant -> Constant -> Bool Source # (>) :: Constant -> Constant -> Bool Source # (>=) :: Constant -> Constant -> Bool Source # max :: Constant -> Constant -> Constant Source # min :: Constant -> Constant -> Constant Source #
Print Constant Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Constant -> Doc Source #

data IdentifierOpt Source #

Constructors

MkIdentifierOptNothing |
MkIdentifierOptJust Identifier |

#### Instances

Instances details

Read IdentifierOpt Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS IdentifierOpt Source # readList :: ReadS [IdentifierOpt] Source # readPrec :: ReadPrec IdentifierOpt Source # readListPrec :: ReadPrec [IdentifierOpt] Source #
Show IdentifierOpt Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> IdentifierOpt -> ShowS Source # show :: IdentifierOpt -> String Source # showList :: [IdentifierOpt] -> ShowS Source #
Eq IdentifierOpt Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: IdentifierOpt -> IdentifierOpt -> Bool Source # (/=) :: IdentifierOpt -> IdentifierOpt -> Bool Source #
Ord IdentifierOpt Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: IdentifierOpt -> IdentifierOpt -> Ordering Source #

(<) :: IdentifierOpt -> IdentifierOpt -> Bool Source #

(<=) :: IdentifierOpt -> IdentifierOpt -> Bool Source #

(>) :: IdentifierOpt -> IdentifierOpt -> Bool Source #

(>=) :: IdentifierOpt -> IdentifierOpt -> Bool Source #

max :: IdentifierOpt -> IdentifierOpt -> IdentifierOpt Source #

min :: IdentifierOpt -> IdentifierOpt -> IdentifierOpt Source #

Print IdentifierOpt Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> IdentifierOpt -> Doc Source #

data CharacterConstant Source #

Constructors

MkCharacterConstant Char |

#### Instances

Instances details

Read CharacterConstant Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS CharacterConstant Source # readList :: ReadS [CharacterConstant] Source # readPrec :: ReadPrec CharacterConstant Source # readListPrec :: ReadPrec [CharacterConstant] Source #
Show CharacterConstant Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> CharacterConstant -> ShowS Source # show :: CharacterConstant -> String Source # showList :: [CharacterConstant] -> ShowS Source #
Eq CharacterConstant Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: CharacterConstant -> CharacterConstant -> Bool Source # (/=) :: CharacterConstant -> CharacterConstant -> Bool Source #
Ord CharacterConstant Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: CharacterConstant -> CharacterConstant -> Ordering Source #

(<) :: CharacterConstant -> CharacterConstant -> Bool Source #

(<=) :: CharacterConstant -> CharacterConstant -> Bool Source #

(>) :: CharacterConstant -> CharacterConstant -> Bool Source #

(>=) :: CharacterConstant -> CharacterConstant -> Bool Source #

max :: CharacterConstant -> CharacterConstant -> CharacterConstant Source #

min :: CharacterConstant -> CharacterConstant -> CharacterConstant Source #

Print CharacterConstant Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> CharacterConstant -> Doc Source #

data FloatingConstant Source #

Constructors

MkFloatingConstant Double |

#### Instances

Instances details

Read FloatingConstant Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS FloatingConstant Source # readList :: ReadS [FloatingConstant] Source # readPrec :: ReadPrec FloatingConstant Source # readListPrec :: ReadPrec [FloatingConstant] Source #
Show FloatingConstant Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> FloatingConstant -> ShowS Source # show :: FloatingConstant -> String Source # showList :: [FloatingConstant] -> ShowS Source #
Eq FloatingConstant Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: FloatingConstant -> FloatingConstant -> Bool Source # (/=) :: FloatingConstant -> FloatingConstant -> Bool Source #
Ord FloatingConstant Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: FloatingConstant -> FloatingConstant -> Ordering Source #

(<) :: FloatingConstant -> FloatingConstant -> Bool Source #

(<=) :: FloatingConstant -> FloatingConstant -> Bool Source #

(>) :: FloatingConstant -> FloatingConstant -> Bool Source #

(>=) :: FloatingConstant -> FloatingConstant -> Bool Source #

max :: FloatingConstant -> FloatingConstant -> FloatingConstant Source #

min :: FloatingConstant -> FloatingConstant -> FloatingConstant Source #

Print FloatingConstant Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> FloatingConstant -> Doc Source #

newtype Identifier Source #

Constructors

Identifier String |

#### Instances

Instances details

IsString Identifier Source # |
Instance details Defined in Language.C.AbsC Methods fromString :: String -> Identifier Source #
Read Identifier Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS Identifier Source # readList :: ReadS [Identifier] Source # readPrec :: ReadPrec Identifier Source # readListPrec :: ReadPrec [Identifier] Source #
Show Identifier Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> Identifier -> ShowS Source # show :: Identifier -> String Source # showList :: [Identifier] -> ShowS Source #
Eq Identifier Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: Identifier -> Identifier -> Bool Source # (/=) :: Identifier -> Identifier -> Bool Source #
Ord Identifier Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: Identifier -> Identifier -> Ordering Source #

(<) :: Identifier -> Identifier -> Bool Source #

(<=) :: Identifier -> Identifier -> Bool Source #

(>) :: Identifier -> Identifier -> Bool Source #

(>=) :: Identifier -> Identifier -> Bool Source #

max :: Identifier -> Identifier -> Identifier Source #

min :: Identifier -> Identifier -> Identifier Source #

Print Identifier Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> Identifier -> Doc Source #

newtype IntegerConstant Source #

Constructors

IntegerConstant String |

#### Instances

Instances details

IsString IntegerConstant Source # |
Instance details Defined in Language.C.AbsC Methods fromString :: String -> IntegerConstant Source #
Read IntegerConstant Source # |
Instance details Defined in Language.C.AbsC Methods readsPrec :: Int -> ReadS IntegerConstant Source # readList :: ReadS [IntegerConstant] Source # readPrec :: ReadPrec IntegerConstant Source # readListPrec :: ReadPrec [IntegerConstant] Source #
Show IntegerConstant Source # |
Instance details Defined in Language.C.AbsC Methods showsPrec :: Int -> IntegerConstant -> ShowS Source # show :: IntegerConstant -> String Source # showList :: [IntegerConstant] -> ShowS Source #
Eq IntegerConstant Source # |
Instance details Defined in Language.C.AbsC Methods (==) :: IntegerConstant -> IntegerConstant -> Bool Source # (/=) :: IntegerConstant -> IntegerConstant -> Bool Source #
Ord IntegerConstant Source # |

Instance details

Defined in Language.C.AbsC

Methods

compare :: IntegerConstant -> IntegerConstant -> Ordering Source #

(<) :: IntegerConstant -> IntegerConstant -> Bool Source #

(<=) :: IntegerConstant -> IntegerConstant -> Bool Source #

(>) :: IntegerConstant -> IntegerConstant -> Bool Source #

(>=) :: IntegerConstant -> IntegerConstant -> Bool Source #

max :: IntegerConstant -> IntegerConstant -> IntegerConstant Source #

min :: IntegerConstant -> IntegerConstant -> IntegerConstant Source #

Print IntegerConstant Source # |
Instance details Defined in Language.C.PrintC Methods prt :: Int -> IntegerConstant -> Doc Source #